



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Gitlab备份和恢复操作记录</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Gitlab备份和恢复操作记录</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:42:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>前面已经介绍了<a href="http://www.cnblogs.com/kevingrace/p/5985918.html" rel="external nofollow noreferrer">Gitlab环境部署记录</a>，这里简单说下Gitlab的备份和恢复操作记录：</p>
<p><strong>1）Gitlab的备份目录路径设置</strong></p>
<div>
<pre class="prettyprint linenums">[root@code-server ~]# vim /etc/gitlab/gitlab.rb<br />
gitlab_rails['manage_backup_path'] = true<br />
gitlab_rails['backup_path'] = "/data/gitlab/backups"    //gitlab备份目录<br />
gitlab_rails['backup_archive_permissions'] = 0644       //生成的备份文件权限<br />
gitlab_rails['backup_keep_time'] = 7776000              //备份保留天数为3个月（即90天，这里是7776000秒）

[root@code-server ~]# mkdir -p /data/gitlab/backups<br />
[root@code-server ~]# chown -R git.git /data/gitlab/backups<br />
[root@code-server ~]# chmod -R 777 /data/gitlab/backups

如上设置了gitlab备份目录路径为/data/gitlab/backups，最后使用下面命令重载gitlab配置文件，是上述修改生效！<br />
root@code-server ~]# gitlab-ctl reconfigure</pre>
</div>
<p><strong>2）GItlab备份操作（使用备份命令"gitlab-rake gitlab:backup:create"）</strong></p>
<div>
<pre class="prettyprint linenums">手动备份gitlab<br />
[root@code-server backups]# gitlab-rake gitlab:backup:create<br />
Dumping database ...<br />
Dumping PostgreSQL database gitlabhq_production ... [DONE]<br />
done<br />
Dumping repositories ...<br />
 * treesign/treesign ... [DONE]<br />
 * gateway/gateway ... [DONE]<br />
 * treesign/treesign-doc ... [SKIPPED]<br />
 * qwsign/qwsign ... [DONE]<br />
 * qwsign/qwsign-doc ... [DONE]<br />
 * test/test ... [DONE]<br />
done<br />
Dumping uploads ...<br />
done<br />
Dumping builds ...<br />
done<br />
Dumping artifacts ...<br />
done<br />
Dumping pages ...<br />
done<br />
Dumping lfs objects ...<br />
done<br />
Dumping container registry images ...<br />
[DISABLED]<br />
Creating backup archive: 1510471890_2017_11_12_9.4.5_gitlab_backup.tar ... done<br />
Uploading backup archive to remote storage  ... skipped<br />
Deleting tmp directories ... done<br />
done<br />
done<br />
done<br />
done<br />
done<br />
done<br />
done<br />
Deleting old backups ... done. (0 removed)

然后查看下备份文件（文件权限是设定好的644）<br />
[root@code-server backups]# ll<br />
total 244<br />
-rw-r--r-- 1 git git 245760 Nov 12 15:33 1510472027_2017_11_12_9.4.5_gitlab_backup.tar

编写备份脚本，结合crontab实施自动定时备份，比如每天0点、6点、12点、18点各备份一次<br />
[root@code-server backups]# pwd<br />
/data/gitlab/backups<br />
[root@code-server backups]# vim gitlab_backup.sh<br />
#!/bin/bash<br />
/usr/bin/gitlab-rake gitlab:backup:create CRON=1

注意：环境变量CRON=1的作用是如果没有任何错误发生时， 抑制备份脚本的所有进度输出

[root@code-server backups]# crontab -l<br />
0 0,6,12,18 * * * /bin/bash -x /data/gitlab/backups/gitlab_backup.sh &gt; /dev/null 2&gt;&amp;1</pre>
</div>
<p><strong>3）Gitlab恢复操作</strong></p>
<div>
<pre class="prettyprint linenums">GItlab只能还原到与备份文件相同的gitlab版本。<br />
假设在上面gitlab备份之前创建了test项目，然后不小心误删了test项目，现在就进行gitlab恢复操作：

1）停止相关数据连接服务<br />
[root@code-server backups]# gitlab-ctl stop unicorn<br />
ok: down: unicorn: 0s, normally up<br />
[root@code-server backups]# gitlab-ctl stop sidekiq<br />
ok: down: sidekiq: 1s, normally up<br />
[root@code-server backups]# gitlab-ctl status<br />
run: gitaly: (pid 98087) 1883s; run: log: (pid 194202) 163003s<br />
run: gitlab-monitor: (pid 98101) 1883s; run: log: (pid 194363) 163002s<br />
run: gitlab-workhorse: (pid 98104) 1882s; run: log: (pid 194362) 163002s<br />
run: logrotate: (pid 98117) 1882s; run: log: (pid 5793) 160832s<br />
run: nginx: (pid 98123) 1881s; run: log: (pid 194359) 163002s<br />
run: node-exporter: (pid 98167) 1881s; run: log: (pid 194360) 163002s<br />
run: postgres-exporter: (pid 98173) 1881s; run: log: (pid 194204) 163003s<br />
run: postgresql: (pid 98179) 1880s; run: log: (pid 194365) 163002s<br />
run: prometheus: (pid 98187) 1880s; run: log: (pid 194364) 163002s<br />
run: redis: (pid 98230) 1879s; run: log: (pid 194358) 163002s<br />
run: redis-exporter: (pid 98234) 1879s; run: log: (pid 194208) 163003s<br />
down: sidekiq: 8s, normally up; run: log: (pid 194437) 163001s<br />
down: unicorn: 21s, normally up; run: log: (pid 194443) 163001s

2）现在通过之前的备份文件进行恢复（必须要备份文件放到备份路径下，这里备份路径我自定义的/data/gitlab/backups，默认的是/var/opt/gitlab/backups）<br />
[root@code-server backups]# pwd<br />
/data/gitlab/backups<br />
[root@code-server backups]# ll<br />
total 244<br />
-rw-r--r-- 1 git git 245760 Nov 12 15:33 1510472027_2017_11_12_9.4.5_gitlab_backup.tar

Gitlab的恢复操作会先将当前所有的数据清空，然后再根据备份数据进行恢复<br />
[root@code-server backups]# gitlab-rake gitlab:backup:restore BACKUP=1510472027_2017_11_12_9.4.5<br />
Unpacking backup ... done<br />
Before restoring the database we recommend removing all existing<br />
tables to avoid future upgrade problems. Be aware that if you have<br />
custom tables in the GitLab database these tables and all data will be<br />
removed.

Do you want to continue (yes/no)?<br />
........<br />
ALTER TABLE<br />
ALTER TABLE<br />
ALTER TABLE<br />
ALTER TABLE<br />
WARNING:  no privileges were granted for "public"<br />
GRANT<br />
[DONE]<br />
done<br />
Restoring repositories ...<br />
 * treesign/treesign ... [DONE]<br />
 * gateway/gateway ... [DONE]<br />
 * treesign/treesign-doc ... [DONE]<br />
 * qwsign/qwsign ... [DONE]<br />
 * qwsign/qwsign-doc ... [DONE]<br />
 * test/test ... [DONE]<br />
Put GitLab hooks in repositories dirs [DONE]<br />
done<br />
Restoring uploads ...<br />
done<br />
Restoring builds ...<br />
done<br />
Restoring artifacts ...<br />
done<br />
Restoring pages ...<br />
done<br />
Restoring lfs objects ...<br />
done<br />
This will rebuild an authorized_keys file.<br />
You will lose any data stored in authorized_keys file.<br />
Do you want to continue (yes/no)? yes

Deleting tmp directories ... done<br />
done<br />
done<br />
done<br />
done<br />
done<br />
done<br />
done<br />
[root@code-server backups]#

最后再次启动Gitlab<br />
[root@code-server backups]# gitlab-ctl start<br />
ok: run: gitaly: (pid 98087) 2138s<br />
ok: run: gitlab-monitor: (pid 98101) 2138s<br />
ok: run: gitlab-workhorse: (pid 98104) 2137s<br />
ok: run: logrotate: (pid 98117) 2137s<br />
ok: run: nginx: (pid 98123) 2136s<br />
ok: run: node-exporter: (pid 98167) 2136s<br />
ok: run: postgres-exporter: (pid 98173) 2136s<br />
ok: run: postgresql: (pid 98179) 2135s<br />
ok: run: prometheus: (pid 98187) 2135s<br />
ok: run: redis: (pid 98230) 2134s<br />
ok: run: redis-exporter: (pid 98234) 2134s<br />
ok: run: sidekiq: (pid 104494) 0s<br />
ok: run: unicorn: (pid 104497) 1s<br />
[root@code-server backups]# gitlab-ctl status<br />
run: gitaly: (pid 98087) 2142s; run: log: (pid 194202) 163262s<br />
run: gitlab-monitor: (pid 98101) 2142s; run: log: (pid 194363) 163261s<br />
run: gitlab-workhorse: (pid 98104) 2141s; run: log: (pid 194362) 163261s<br />
run: logrotate: (pid 98117) 2141s; run: log: (pid 5793) 161091s<br />
run: nginx: (pid 98123) 2140s; run: log: (pid 194359) 163261s<br />
run: node-exporter: (pid 98167) 2140s; run: log: (pid 194360) 163261s<br />
run: postgres-exporter: (pid 98173) 2140s; run: log: (pid 194204) 163262s<br />
run: postgresql: (pid 98179) 2139s; run: log: (pid 194365) 163261s<br />
run: prometheus: (pid 98187) 2139s; run: log: (pid 194364) 163261s<br />
run: redis: (pid 98230) 2138s; run: log: (pid 194358) 163261s<br />
run: redis-exporter: (pid 98234) 2138s; run: log: (pid 194208) 163262s<br />
run: sidekiq: (pid 104494) 4s; run: log: (pid 194437) 163260s<br />
run: unicorn: (pid 104497) 4s; run: log: (pid 194443) 163260s

恢复命令完成后，可以check检查一下恢复情况<br />
[root@code-server backups]# gitlab-rake gitlab:check SANITIZE=true<br />
Checking GitLab Shell ...

GitLab Shell version &gt;= 5.3.1 ? ... OK (5.3.1)<br />
Repo base directory exists?<br />
default... yes<br />
Repo storage directories are symlinks?<br />
default... no<br />
Repo paths owned by git:root, or git:git?<br />
default... yes<br />
Repo paths access is drwxrws---?<br />
default... yes<br />
hooks directories in repos are links: ...<br />
5/1 ... ok<br />
6/2 ... ok<br />
5/3 ... repository is empty<br />
12/4 ... ok<br />
12/5 ... ok<br />
Running /opt/gitlab/embedded/service/gitlab-shell/bin/check<br />
Check GitLab API access: OK<br />
Access to /var/opt/gitlab/.ssh/authorized_keys: OK<br />
Send ping to redis server: OK<br />
gitlab-shell self-check successful

Checking GitLab Shell ... Finished

Checking Sidekiq ...

Running? ... yes<br />
Number of Sidekiq processes ... 1

Checking Sidekiq ... Finished

Checking Reply by email ...

Reply by email is disabled in config/gitlab.yml

Checking Reply by email ... Finished

Checking LDAP ...

LDAP is disabled in config/gitlab.yml

Checking LDAP ... Finished

Checking GitLab ...

Git configured correctly? ... yes<br />
Database config exists? ... yes<br />
All migrations up? ... yes<br />
Database contains orphaned GroupMembers? ... no<br />
GitLab config exists? ... yes<br />
GitLab config up to date? ... yes<br />
Log directory writable? ... yes<br />
Tmp directory writable? ... yes<br />
Uploads directory exists? ... yes<br />
Uploads directory has correct permissions? ... yes<br />
Uploads directory tmp has correct permissions? ... yes<br />
Init script exists? ... skipped (omnibus-gitlab has no init script)<br />
Init script up-to-date? ... skipped (omnibus-gitlab has no init script)<br />
Projects have namespace: ...<br />
5/1 ... yes<br />
6/2 ... yes<br />
5/3 ... yes<br />
12/4 ... yes<br />
12/5 ... yes<br />
Redis version &gt;= 2.8.0? ... yes<br />
Ruby version &gt;= 2.3.3 ? ... yes (2.3.3)<br />
Git version &gt;= 2.7.3 ? ... yes (2.13.4)<br />
Active users: ... 11

Checking GitLab ... Finished

然后稍等一会（如果启动gitlab后，访问出现500，这是因为redis等程序还没完全启动，等一会儿访问就ok了），再次登录Gitlab，就会发现之前误删除的test项目已经恢复了！

另外：Gitlab迁移与恢复一样，但是要求两个GitLab版本号一致</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49ggyz97.html">XCodeGhost表明：为了安全，开发工具应该从官方网站下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyypomq.html">EC笔记：第二部分：11：在operator&equals;中处理&OpenCurlyDoubleQuote;自我赋值&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kody6q.html">J2EE基础之JavaBean</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ov7dxq.html">nginx expires</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kdmej9.html">&lbrack;Linux监控&rsqb;磁盘空间大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8opeypq.html">Oracle 时间，日期 类型函数及参数详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q276xv8.html">J2SE 1&period;6 特性：java&period;lang&period;instrument</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z11lk19.html">Windows定时器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdm1gr8.html">wildfly-9&period;0&period;2 web项目部署详细步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvyo6xq.html">&lbrack;CSAPP笔记&rsqb;&lbrack;第九章虚拟存储器&rsqb;&lbrack;吐血1500行&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1wkj69.html">php pdo mysql数据库操作类</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z15kex9.html">在MyEclipse中统计项目行数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1ewxzq.html">PHP识别电脑还是手机访问网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rk3jz8.html">Springboot访问静态资源</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25vdewq.html">贪心之oj&period;1797</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll72oeq.html">java mail smtp port</a>
		</li>
						<li><a href="https://www.batexi.com/a/960nj039.html">CentOS Nginx网站服务器搭建实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jo03jq.html">Vue 使用 vuelidate 实现表单验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjx1rj9.html">PHP 中 call&lowbar;user&lowbar;func 函数 和 call&lowbar;user&lowbar;func&lowbar;array 函数的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9601jlv9.html">Cannot find a valid baseurl for repo&colon; base&sol;7&sol;x86&lowbar;64</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9r5wlmrq.html">nodejs在spawn中执行npm报错  &lbrack;Error&colon; spawn ENOENT&rsqb;&rdquo; errors</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r1xjj9.html">Sublime Text 3 注册码激活码被移除的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyojg2q.html">系统运维&vert;SqlServer2008&vert;数据库日志文件过大需要清理的操作攻略</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5wrjdq.html">Django框架的使用教程--环境的搭建和项目的创建&lbrack;一&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rd7o08.html">第 15 章 位操作（fields）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q256zlxq.html">C&num; 连接Oracle时报错的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gn4wzq.html">C&plus;&plus;整形转化成string类型---路径拼接在批处理程序中的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd4pvv9.html">eclipse 自动创建web&period;xml</a>
			</li>
						<li><a href="https://www.batexi.com/a/q256r6oq.html">php获取两个数组相同的元素（交集）以及比较两个数组中不同的元素（差集）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjdwx59.html">小度之家SDK功能介绍</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
